summaryrefslogtreecommitdiffstats
path: root/Tools/gcc
diff options
context:
space:
mode:
authorbbahnsen <bbahnsen@6f19259b-4bc3-4df7-8a09-765794883524>2006-04-26 23:04:39 +0000
committerbbahnsen <bbahnsen@6f19259b-4bc3-4df7-8a09-765794883524>2006-04-26 23:04:39 +0000
commitb8f302f88c4ea1cf48e5790f4776dd577549db2b (patch)
tree221cf559903e0a3931219eecbfe181202a716e29 /Tools/gcc
parent22e0585cf8d24a7337400d5e49295737ffc000f2 (diff)
downloadedk2-b8f302f88c4ea1cf48e5790f4776dd577549db2b.tar.gz
edk2-b8f302f88c4ea1cf48e5790f4776dd577549db2b.tar.bz2
edk2-b8f302f88c4ea1cf48e5790f4776dd577549db2b.zip
Add the gcc cross compile build scripts.
git-svn-id: https://edk2.svn.sourceforge.net/svnroot/edk2/trunk/edk2@58 6f19259b-4bc3-4df7-8a09-765794883524
Diffstat (limited to 'Tools/gcc')
-rw-r--r--Tools/gcc/README.txt16
-rw-r--r--Tools/gcc/tianoCross-gcc-4.0140
-rw-r--r--Tools/gcc/tianoCross-gcc-4.1138
3 files changed, 294 insertions, 0 deletions
diff --git a/Tools/gcc/README.txt b/Tools/gcc/README.txt
new file mode 100644
index 0000000000..0ec853d386
--- /dev/null
+++ b/Tools/gcc/README.txt
@@ -0,0 +1,16 @@
+You may run these scripts to build a Tiano Cross compiler. They have been
+tested on Cygwin, OS X and Linux. You should expect to hack on these scripts to
+make them work on your system. You may need to install additional tools on your
+system to make the scripts work.
+
+You will need
+
+ A recent version of gcc that is able to produce executables for the machine
+ that you want to run this compiler on (the host machine).
+ wget or curl
+ tar
+ bzip
+ gzip
+ bash
+ and possibly others
+
diff --git a/Tools/gcc/tianoCross-gcc-4.0 b/Tools/gcc/tianoCross-gcc-4.0
new file mode 100644
index 0000000000..19e2c82569
--- /dev/null
+++ b/Tools/gcc/tianoCross-gcc-4.0
@@ -0,0 +1,140 @@
+#!/bin/bash
+
+#
+# Get, build and install the latest cross-development tools and libraries
+#
+
+#
+# Specify the architectures for which the tools are to be built
+# To build for single target: ARCHS="m68k"
+#
+ARCHS="${ARCHS:-i386}"
+
+# Let's be nice
+renice 10 -p $$
+
+# If any thing goes wrong, we'll bail out.
+set -ex
+
+#
+# Specify the versions
+#
+GCC=gcc-4.0.2
+BINUTILS=binutils-2.16.1
+CYGWIN_SNAP=20060120 # You may need to find a more recent one.
+
+#
+# Where to install
+#
+PREFIX="${PREFIX:-/opt/tiano/}"
+
+#
+# Where to get the GNU tools
+#
+BINUTILS_URL=ftp://ftp.ibiblio.org/pub/mirrors/gnu/ftp/gnu/binutils/${BINUTILS}.tar.bz2
+GCC_URL=ftp://ftp.ibiblio.org/pub/mirrors/gnu/ftp/gnu/gcc/gcc-4.0.2/${GCC}.tar.bz2
+CYG_LOC=http://cygwin.com/snapshots/cygwin-src-${CYGWIN_SNAP}.tar.bz2
+export http_proxy=http://proxy.dp.intel.com:911
+export ftp_proxy=http://proxy.dp.intel.com:911
+
+#
+# Uncomment one of the following depending upon which your system provides
+#
+GET_COMMAND="curl --remote-name"
+#GET_COMMAND="wget -nc --no-directories --retr-symlinks "
+
+#
+# Allow environment to override some programs
+#
+MAKE="${MAKE:-make}"
+export MAKE
+SHELL="${SHELL:-/bin/sh}"
+export SHELL
+
+#
+# Get the source
+# If you don't have curl on your machine, try using
+# wget --passive-ftp --no-directories --retr-symlinks <<url>>
+# If that doesn't work, try without the --passive-ftp option.
+#
+getSource() {
+ ${GET_COMMAND} "${BINUTILS_URL}" &
+ ${GET_COMMAND} "${GCC_URL}" &
+ ${GET_COMMAND} "${CYG_LOC}" &
+ wait
+}
+
+#
+# Unpack the source
+#
+unpackSource() {
+ (rm -rf "${BINUTILS}"
+ tar jxf "${BINUTILS}.tar.bz2"
+ ) &
+
+ (rm -rf "${GCC}"
+ tar jxf "${GCC}.tar.bz2"
+ ) &
+
+ (rm -rf cygwin-snapshot-${CYGWIN_SNAP}-1/
+ tar jxf cygwin-src-${CYGWIN_SNAP}.tar.bz2
+ ) &
+
+ wait
+
+ # (cd "${GCC}" ; ln -sf "../cygwin-snapshot-20060120-1/newlib" newlib)
+
+}
+
+CONF_SHELL="${CONF_SHELL:-/bin/bash}"
+# CONF_SHELL="${CONF_SHELL:-echo}"
+
+#
+# Build
+#
+build() {
+ for arch in $ARCHS
+ do (
+ export targ=${arch}-tiano-pe
+ export pref=${PREFIX}${targ}
+ export PATH="${pref}/bin:$PATH"
+
+ ( mkdir -p build-binutils-$targ
+ cd build-binutils-$targ
+ "${CONF_SHELL}" "../${BINUTILS}/configure" \
+ --disable-nls "--target=${targ}" "--prefix=${pref}"
+ ${MAKE} -j1 -w all
+ ${MAKE} -w install
+ ) >> ${targ}.log 2>&1
+
+ (
+ mkdir -p $pref/$targ/sys-include;
+ cp -fr cygwin-snapshot-${CYGWIN_SNAP}-1/newlib/libc/include/* $pref/$targ/sys-include
+ cp -fr cygwin-snapshot-${CYGWIN_SNAP}-1/winsup/cygwin/include/* $pref/$targ/sys-include
+ )
+
+ ( mkdir -p build-gcc-$targ
+ cd build-gcc-$targ
+ "${CONF_SHELL}" "../${GCC}/configure" "--target=${targ}" "--prefix=${pref}" \
+ --with-gnu-as --with-gnu-ld --with-newlib --verbose \
+ --disable-nls --enable-languages=c
+ ${MAKE} -j1 -w all
+ ${MAKE} -w install
+ ) >> ${targ}.log 2>&1
+ ) &
+ done
+
+ wait
+}
+
+
+
+#
+# Do everything
+#
+# Comment out any activities you wish to omit
+#
+getSource
+unpackSource
+build
+
diff --git a/Tools/gcc/tianoCross-gcc-4.1 b/Tools/gcc/tianoCross-gcc-4.1
new file mode 100644
index 0000000000..2b4e5abeb3
--- /dev/null
+++ b/Tools/gcc/tianoCross-gcc-4.1
@@ -0,0 +1,138 @@
+#!/bin/bash
+
+#
+# Get, build and install the latest cross-development tools and libraries
+#
+
+#
+# Specify the architectures for which the tools are to be built
+# To build for single target: ARCHS="m68k"
+#
+ARCHS="${ARCHS:-i386}"
+
+# Let's be nice
+renice 10 -p $$
+
+# If any thing goes wrong, we'll bail out.
+set -e
+
+#
+# Specify the versions
+#
+GCC=gcc-4.1.0
+# BINUTILS=binutils-2.16.1
+BINUTILS=binutils-2.16.91-20060119-1
+CYGWIN_SNAP=20060403 # You may need to find a more recent one.
+
+#
+# Where to install
+#
+PREFIX="${PREFIX:-/opt/tiano/}"
+
+#
+# Where to get the GNU tools
+#
+BINUTILS_URL=http://superb.dl.sourceforge.net/sourceforge/mingw/${BINUTILS}-src.tar.gz
+GCC_URL=http://mirrors.ibiblio.org/pub/mirrors/gnu/ftp/gnu/gcc/gcc-${GCC}/${GCC}.tar.bz2
+CYG_LOC=http://cygwin.com/snapshots/cygwin-src-${CYGWIN_SNAP}.tar.bz2
+# export http_proxy=http://proxy.dp.intel.com:911
+# export ftp_proxy=http://proxy.dp.intel.com:911
+
+#
+# Uncomment one of the following depending upon which your system provides
+#
+GET_COMMAND="curl --remote-name"
+#GET_COMMAND="wget -nc --no-directories --retr-symlinks "
+
+#
+# Allow environment to override some programs
+#
+MAKE="${MAKE:-make}"
+export MAKE
+SHELL="${SHELL:-/bin/sh}"
+export SHELL
+
+#
+# Get the source
+# If you don't have curl on your machine, try using
+# wget --passive-ftp --no-directories --retr-symlinks <<url>>
+# If that doesn't work, try without the --passive-ftp option.
+#
+getSource() {
+ ${GET_COMMAND} "${BINUTILS_URL}" &
+ ${GET_COMMAND} "${GCC_URL}" &
+ ${GET_COMMAND} "${CYG_LOC}" &
+ wait
+}
+
+#
+# Unpack the source
+#
+unpackSource() {
+ (rm -rf "${BINUTILS}"
+ tar zxf "${BINUTILS}-src.tar.gz"
+ ) &
+
+ (rm -rf "${GCC}"
+ tar jxf "${GCC}.tar.bz2"
+ ) &
+
+ (rm -rf cygwin-snapshot-${CYGWIN_SNAP}-1/
+ tar jxf cygwin-src-${CYGWIN_SNAP}.tar.bz2
+ ) &
+
+ wait
+}
+
+CONF_SHELL="${CONF_SHELL:-/bin/bash}"
+# CONF_SHELL="${CONF_SHELL:-echo}"
+
+#
+# Build
+#
+build() {
+ for arch in $ARCHS
+ do (
+ export targ=${arch}-tiano-pe
+ export pref=${PREFIX}${targ}
+ export PATH="${pref}/bin:$PATH"
+
+ ( mkdir -p build-binutils-$targ
+ cd build-binutils-$targ
+ "${CONF_SHELL}" "../${BINUTILS}/configure" \
+ --disable-nls "--target=${targ}" "--prefix=${pref}"
+ ${MAKE} -j5 -w all
+ ${MAKE} -w install
+ ) >> ${targ}.log 2>&1
+
+ (
+ mkdir -p $pref/$targ/sys-include;
+ cp -fr cygwin-snapshot-${CYGWIN_SNAP}-1/newlib/libc/include/* $pref/$targ/sys-include
+ cp -fr cygwin-snapshot-${CYGWIN_SNAP}-1/winsup/cygwin/include/* $pref/$targ/sys-include
+ )
+
+ ( mkdir -p build-gcc-$targ
+ cd build-gcc-$targ
+ "${CONF_SHELL}" "../${GCC}/configure" "--target=${targ}" "--prefix=${pref}" \
+ --with-gnu-as --with-gnu-ld --with-newlib --verbose \
+ --disable-libssp \
+ --disable-nls --enable-languages=c
+ ${MAKE} -j5 -w all
+ ${MAKE} -w install
+ ) >> ${targ}.log 2>&1
+ ) &
+ done
+
+ wait
+}
+
+
+
+#
+# Do everything
+#
+# Comment out any activities you wish to omit
+#
+getSource
+unpackSource
+build